Index: Makefile.todo
===================================================================
--- Makefile.todo	(revision b2e1123733db8fd1a83a893e980a9fe4da357bb6)
+++ Makefile.todo	(revision b6c64e1447f155d2d4afd65216360fb1c144d0fb)
@@ -1,2 +1,6 @@
+BASE = $(PWD)
+
+BUILD_BSP = $(BASE)/build/arm-rtems5-xilinx_zynq_a9_qemu-everything
+
 LOCAL_INC = rtemsbsd/include/rtems/bsd/local
 
@@ -65,4 +69,17 @@
 all: yacc lex $(GENERATED)
 
+program-header:
+	cd freebsd/bin/stty && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/bin/stty/*.o -p stty
+	cd freebsd/contrib/tcpdump && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/contrib/tcpdump/*.o -p tcpdump
+	cd freebsd/sbin/ifconfig && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/sbin/ifconfig/*.o -p ifconfig
+	cd freebsd/sbin/pfctl && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/sbin/pfctl/*.o -p pfctl
+	cd freebsd/sbin/ping6 && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/sbin/ping6/*.o -p ping6
+	cd freebsd/sbin/ping && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/sbin/ping/*.o -p ping
+	cd freebsd/sbin/route && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/sbin/route/*.o -p route
+	cd freebsd/sbin/sysctl && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/sbin/sysctl/*.o -p sysctl
+	cd freebsd/tools/tools/net80211/wlanstats && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/tools/tools/net80211/wlanstats/*.o -p wlanstats
+	cd freebsd/usr.bin/netstat && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/usr.bin/netstat/*.o -p netstat
+	cd freebsd/usr.sbin/arp && $(BASE)/userspace-header-gen.py $(BUILD_BSP)/freebsd/usr.sbin/arp/*.o -p arp
+
 $(LOCAL_INC)/usbdevs.h: $(FREEBSD_SRC)/sys/dev/usb/usbdevs
 	awk -f $(TOOLS)/usbdevs2h.awk $< -h
Index: freebsd/bin/stty/rtems-bsd-stty-key-data.h
===================================================================
--- freebsd/bin/stty/rtems-bsd-stty-key-data.h	(revision b2e1123733db8fd1a83a893e980a9fe4da357bb6)
+++ freebsd/bin/stty/rtems-bsd-stty-key-data.h	(revision b6c64e1447f155d2d4afd65216360fb1c144d0fb)
@@ -3,3 +3,3 @@
 #include "rtems-bsd-stty-data.h"
 /* key.c */
-RTEMS_LINKER_RWSET_CONTENT(bsd_prog_stty, static struct key keys[20]);
+RTEMS_LINKER_RWSET_CONTENT(bsd_prog_stty, static struct key keys[]);
Index: freebsd/sbin/pfctl/parse.c
===================================================================
--- freebsd/sbin/pfctl/parse.c	(revision b2e1123733db8fd1a83a893e980a9fe4da357bb6)
+++ freebsd/sbin/pfctl/parse.c	(revision b6c64e1447f155d2d4afd65216360fb1c144d0fb)
@@ -2572,6 +2572,4 @@
 #line 4551 "parse.y"
 #ifdef __rtems__
-RTEMS_LINKER_RWSET_CONTENT(bsd_prog_pfctl, extern YYSTYPE pfctlyval);
-RTEMS_LINKER_RWSET_CONTENT(bsd_prog_pfctl, extern YYSTYPE pfctlylval);
 RTEMS_LINKER_RWSET_CONTENT(bsd_prog_pfctl, static YYSTACKDATA yystack);
 #endif /* __rtems__ */
Index: freebsd/sbin/pfctl/parse.y
===================================================================
--- freebsd/sbin/pfctl/parse.y	(revision b2e1123733db8fd1a83a893e980a9fe4da357bb6)
+++ freebsd/sbin/pfctl/parse.y	(revision b6c64e1447f155d2d4afd65216360fb1c144d0fb)
@@ -4550,6 +4550,4 @@
 %%
 #ifdef __rtems__
-RTEMS_LINKER_RWSET_CONTENT(bsd_prog_pfctl, extern YYSTYPE pfctlyval);
-RTEMS_LINKER_RWSET_CONTENT(bsd_prog_pfctl, extern YYSTYPE pfctlylval);
 RTEMS_LINKER_RWSET_CONTENT(bsd_prog_pfctl, static YYSTACKDATA yystack);
 #endif /* __rtems__ */
Index: freebsd/usr.bin/netstat/rtems-bsd-netstat-namespace.h
===================================================================
--- freebsd/usr.bin/netstat/rtems-bsd-netstat-namespace.h	(revision b2e1123733db8fd1a83a893e980a9fe4da357bb6)
+++ freebsd/usr.bin/netstat/rtems-bsd-netstat-namespace.h	(revision b6c64e1447f155d2d4afd65216360fb1c144d0fb)
@@ -7,77 +7,75 @@
 #define intpr _bsd_netstat_intpr
 /* inet6.c */
+#define icmp6_ifstats _bsd_netstat_icmp6_ifstats
+#define icmp6_stats _bsd_netstat_icmp6_stats
 #define inet6name _bsd_netstat_inet6name
 #define inet6print _bsd_netstat_inet6print
-#define rip6_stats _bsd_netstat_rip6_stats
-#define pim6_stats _bsd_netstat_pim6_stats
-#define icmp6_ifstats _bsd_netstat_icmp6_ifstats
-#define icmp6_stats _bsd_netstat_icmp6_stats
 #define ip6_ifstats _bsd_netstat_ip6_ifstats
 #define ip6_stats _bsd_netstat_ip6_stats
+#define pim6_stats _bsd_netstat_pim6_stats
+#define rip6_stats _bsd_netstat_rip6_stats
 /* inet.c */
+#define arp_stats _bsd_netstat_arp_stats
+#define carp_stats _bsd_netstat_carp_stats
+#define icmp_stats _bsd_netstat_icmp_stats
+#define igmp_stats _bsd_netstat_igmp_stats
 #define inetname _bsd_netstat_inetname
 #define inetprint _bsd_netstat_inetprint
+#define ip_stats _bsd_netstat_ip_stats
 #define pim_stats _bsd_netstat_pim_stats
-#define igmp_stats _bsd_netstat_igmp_stats
-#define icmp_stats _bsd_netstat_icmp_stats
-#define arp_stats _bsd_netstat_arp_stats
-#define ip_stats _bsd_netstat_ip_stats
-#define carp_stats _bsd_netstat_carp_stats
-#define udp_stats _bsd_netstat_udp_stats
-#define tcp_stats _bsd_netstat_tcp_stats
 #define protopr _bsd_netstat_protopr
 #define sotoxsocket _bsd_netstat_sotoxsocket
+#define tcp_stats _bsd_netstat_tcp_stats
+#define udp_stats _bsd_netstat_udp_stats
 /* ipsec.c */
 /* main.c */
 #define Aflag _bsd_netstat_Aflag
+#define Lflag _bsd_netstat_Lflag
+#define Rflag _bsd_netstat_Rflag
+#define Tflag _bsd_netstat_Tflag
+#define Wflag _bsd_netstat_Wflag
 #define aflag _bsd_netstat_aflag
 #define bflag _bsd_netstat_bflag
 #define dflag _bsd_netstat_dflag
+#define fetch_stats _bsd_netstat_fetch_stats
+#define fetch_stats_ro _bsd_netstat_fetch_stats_ro
 #define gflag _bsd_netstat_gflag
 #define hflag _bsd_netstat_hflag
 #define iflag _bsd_netstat_iflag
-#define Lflag _bsd_netstat_Lflag
+#define interface _bsd_netstat_interface
+#define interval _bsd_netstat_interval
+#define kread _bsd_netstat_kread
+#define kread_counters _bsd_netstat_kread_counters
+#define live _bsd_netstat_live
 #define mflag _bsd_netstat_mflag
 #define noutputs _bsd_netstat_noutputs
 #define numeric_addr _bsd_netstat_numeric_addr
 #define numeric_port _bsd_netstat_numeric_port
+#define plural _bsd_netstat_plural
+#define plurales _bsd_netstat_plurales
+#define pluralies _bsd_netstat_pluralies
 #define rflag _bsd_netstat_rflag
-#define Rflag _bsd_netstat_Rflag
 #define sflag _bsd_netstat_sflag
-#define Wflag _bsd_netstat_Wflag
-#define Tflag _bsd_netstat_Tflag
+#define unit _bsd_netstat_unit
 #define xflag _bsd_netstat_xflag
 #define zflag _bsd_netstat_zflag
-#define interval _bsd_netstat_interval
-#define interface _bsd_netstat_interface
-#define unit _bsd_netstat_unit
-#define live _bsd_netstat_live
-#define pluralies _bsd_netstat_pluralies
-#define plurales _bsd_netstat_plurales
-#define plural _bsd_netstat_plural
-#define kread_counters _bsd_netstat_kread_counters
-#define kread_counter _bsd_netstat_kread_counter
-#define kread _bsd_netstat_kread
-#define kset_dpcpu _bsd_netstat_kset_dpcpu
-#define fetch_stats_ro _bsd_netstat_fetch_stats_ro
-#define fetch_stats _bsd_netstat_fetch_stats
 /* mbuf.c */
 #define mbpr _bsd_netstat_mbpr
 /* mroute6.c */
+#define mroute6pr _bsd_netstat_mroute6pr
 #define mrt6_stats _bsd_netstat_mrt6_stats
-#define mroute6pr _bsd_netstat_mroute6pr
 /* mroute.c */
+#define mroutepr _bsd_netstat_mroutepr
 #define mrt_stats _bsd_netstat_mrt_stats
-#define mroutepr _bsd_netstat_mroutepr
 /* nl_symbols.c */
 #define nl _bsd_netstat_nl
 /* pfkey.c */
 /* route.c */
-#define rt_stats _bsd_netstat_rt_stats
 #define in6_fillscopeid _bsd_netstat_in6_fillscopeid
 #define netname _bsd_netstat_netname
+#define pr_family _bsd_netstat_pr_family
 #define routename _bsd_netstat_routename
-#define pr_family _bsd_netstat_pr_family
 #define routepr _bsd_netstat_routepr
+#define rt_stats _bsd_netstat_rt_stats
 /* sctp.c */
 /* unix.c */
